;;; guile-irrlicht --- FFI bindings for Irrlicht Engine
;;; Copyright (C) 2020 Javier Sancho <jsf@jsancho.org>
;;;
;;; This file is part of guile-irrlicht.
;;;
;;; Guile-irrlicht is free software; you can redistribute it and/or modify
;;; it under the terms of the GNU Lesser General Public License as
;;; published by the Free Software Foundation; either version 3 of the
;;; License, or (at your option) any later version.
;;;
;;; Guile-irrlicht is distributed in the hope that it will be useful, but
;;; WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;;; General Public License for more details.
;;;
;;; You should have received a copy of the GNU Lesser General Public
;;; License along with guile-irrlicht.  If not, see
;;; <http://www.gnu.org/licenses/>.


(define-module (irrlicht core)
  #:use-module (oop goops)
  #:use-module (irrlicht base)
  #:use-module (irrlicht foreign))


;; aabbox3d
(define-class <box3d> (<irrlicht-base>)
  (irr-class #:init-value "aabbox3d"))

(define-method (add-internal-point! (box3d <box3d>) point)
  (let ((addInternalPoint (get-irrlicht-proc "aabbox3d_addInternalPoint")))
    (addInternalPoint box3d point)))

(define (make-box3d)
  (let ((aabbox3d_make (get-irrlicht-proc "aabbox3d_make")))
    (make <box3d> #:irr-pointer (aabbox3d_make))))

(define-method (reset-box3d! (box3d <box3d>) init-value)
  (let ((reset (get-irrlicht-proc "aabbox3d_reset")))
    (reset box3d init-value)))

(export <box3d> add-internal-point! make-box3d reset-box3d!)
